#!/usr/bin/python3

from minmax import *

# SPÉCIFIQUE AU MORPION

# état du morpion
# une matrice 3x3
# on pourrait ajouter le nombre de cases vides
# on pourrait ajouter la liste des cases vides

# joueurs = X et O

# un coup = coordonnées (ligne,colonne) d'une case vide

def copie_matrice (matrice) :
    return [
        [matrice[0][0],matrice[0][1],matrice[0][2]],
        [matrice[1][0],matrice[1][1],matrice[1][2]],
        [matrice[2][0],matrice[2][1],matrice[2][2]]
    ]


def liste_cases_vides (matrice):
    vides = []
    for nl in range(3):
        for nc in range(3):
            if matrice[nl][nc]==' ':
                vides.append((nl,nc))
    return vides

def présence_ligne (matrice,symbole):
    ligne = [symbole,symbole,symbole]
    return ((matrice[0] == ligne)
            or (matrice[1] == ligne)
            or (matrice[2] == ligne)
    
            or ([ matrice[0][0],matrice[1][0],matrice[2][0] ] == ligne)
            or ([ matrice[0][1],matrice[1][1],matrice[2][1] ] == ligne)
            or ([ matrice[0][2],matrice[1][2],matrice[2][2] ] == ligne)

            or ([ matrice[0][0],matrice[1][1],matrice[2][2] ] == ligne)
            or ([ matrice[0][2],matrice[1][1],matrice[2][0] ] == ligne))



# bonus


def matrice_en_texte (matrice) :
    trait = "  ·———·———·———·\n"
    texte = trait
    for i in range(3):
        ligne =matrice[i]
        texte += str(i+1)+" | "+ligne[0]+" | "+ligne[1]+" | "+ligne[2]+" |\n"
        texte += trait
    texte += "    1   2   3\n"
    return texte


def affiche_matrice (matrice) :
    print()
    print(matrice_en_texte(matrice))



def adversaire (joueur) :
    if joueur=='X':
        return 'O'
    else:
        return 'X'

    
# INSTANCIATION DES FONCTIONS GÉNÉRIQUES POUR LE MORPION

def coups_possibles (état,joueur):
    return liste_cases_vides(état)


def applique_coup (état,joueur,coup):
    nm = copie_matrice(état)
    (ligne,colonne) = coup
    nm[ligne][colonne] = joueur
    return nm


def fin_partie (état,id_minmax,adversaire,mon_tour):
    if (présence_ligne(état,"X")):
        return (True,"X")
    elif (présence_ligne(état,"O")):
          return (True,"O")
    elif (liste_cases_vides(état)==[]):
        return (True,"")
    else:
        return (False,"")


# pour l'interaction avec l'utilisateur

def int_input (msg):
    try:
        val = int(input(msg))
    except ValueError:
        val = -1
    return val


état_initial = [[' ',' ',' '],[' ',' ',' '],[' ',' ',' ']]


# APPELS DES FONCTIONS DE JEU

état_courant = état_initial
#état_courant = [['X',' ','X'],[' ','O',' '],[' ',' ','O']]

joueuria = "X"
humain   = adversaire(joueuria)

humain_joue = True # qui commence ?

partie_en_cours = True

affiche_matrice(état_courant)
        
while (partie_en_cours) :
    
    # au joueur humain de jouer...
    if humain_joue :
        saisie_ok = False
        while not saisie_ok:
            lig = int_input("  Ligne de votre coup  : ")-1
            col = int_input("Colonne de votre coup  : ")-1
            if ((lig in range(0,3)) and (col in range(0,3)) and état_courant[lig][col]==" ") :
                saisie_ok = True
            else:
                print("On recommence...")
        état_courant = applique_coup(état_courant,humain,(lig,col))
        affiche_matrice(état_courant)
        
        (terminée,gagnant) = fin_partie(état_courant,joueuria,humain,True)
    else:
        humain_joue = True
        terminée    = False
        
    # au tour de MinMax
    if not terminée :
        
        ((lig,col),score) = DecisionMinMax(état_courant,joueuria,humain,fin_partie,coups_possibles,applique_coup)
        état_courant = applique_coup(état_courant,joueuria,(lig,col))

        print("  Coup choisi par MinMax :",lig+1,"x",col+1)
        affiche_matrice(état_courant)    
        print("  Valeur :",score)
        print()
        
        (terminée,gagnant) = fin_partie(état_courant,joueuria,humain,False)
    
    if terminée:
        partie_en_cours = False
        if gagnant == "":
            print("Match nul.")
        else:
            print("Victoire pour les",gagnant)
