
def affiche_pas_de_solution ():
        print("\tpas de solution")

def affiche_état (et) :
        print(et)

def affiche_opérateur (nom) :
        print("\t",nom,sep="")

def affiche_succès (nb_étapes) :
        print("\t>> solution trouvée en "+str(nb_étapes)+" opérations.")
        
def affiche_titre (titre) :
        print("\t",titre," : ",sep="",end="")

def affiche_but (phrase):
        print(phrase)
                
                

# un opérateur = un triplet (nom,précondition,action)

# constructeur
def nouvel_operateur (n,p,a):
	return (n,p,a)

# accesseurs
def nom_operateur(o) :
	return o[0]

def precondition_operateur(o) :
	return o[1]

def action_operateur(o) :
	return o[2]

# test opérateur applicable à un état
def est_applicable(o,e) :
	precond = precondition_operateur(o)
	return precond(e)

# liste des opérateurs applicables à un état
def sélection_opérateurs_applicables(os,e):
	res = []
	for o in os:
		if est_applicable(o,e):
			res.append(o)
	return res

# applique un opérateur à un état
def applique_operateur(o,e) :
	action = action_operateur(o)
	return action(e)

def affiche_solution (e,ops,etat_en_texte):
        print()
        if ops == None:
                affiche_pas_de_solution()
        else:
                affiche_état(etat_en_texte(e))
                for o in ops:
                        e = applique_operateur(o,e)
                        affiche_opérateur(nom_operateur(o))
                        print()
                        affiche_état(etat_en_texte(e))
                print()
                affiche_succès(len(ops))
        print()

        
# RECHERCHES EN PROFONDEUR
                
def recherche_en_profondeur_rec (e,est_final,opérateurs_applicables,etat_en_texte,deja):
        if (est_final(e)) :
                return []
        else:
                etxt = etat_en_texte(e)
                if etxt in deja:
                        return None
                else:
                        deja[etxt] = 1
                        applicables = opérateurs_applicables(e)
                        for o in applicables:
                                succ = applique_operateur(o,e)
                                chemin = recherche_en_profondeur_rec(succ,est_final,opérateurs_applicables,etat_en_texte,deja)
                                if chemin!=None:
                                        return [ o ] + chemin
                        return None
        

def recherche_en_profondeur_rec_lim (e,est_final,opérateurs_applicables,etat_en_texte,deja,lim):
        if (est_final(e)) :
                return []
        elif (lim==0):
                return None
        else:
                etxt = etat_en_texte(e)
                if etxt in deja:
                        return None
                else:
                        ndeja       = dict(deja)
                        ndeja[etxt] = 1
                        applicables = opérateurs_applicables(e)
                        for o in applicables:
                                succ = applique_operateur(o,e)
                                chemin = recherche_en_profondeur_rec_lim(succ,est_final,opérateurs_applicables,etat_en_texte,ndeja,lim-1)
                                if chemin!=None:
                                        return [ o ] + chemin
                        return None
        
def recherche_en_profondeur (etat_initial,est_final,opérateurs_applicables,etat_en_texte) :
        ch = recherche_en_profondeur_rec(etat_initial,est_final,opérateurs_applicables,etat_en_texte,{})
        affiche_solution(etat_initial,ch,etat_en_texte)

def recherche_en_profondeur_limitée (etat_initial,est_final,opérateurs_applicables,etat_en_texte,limite) :
        ch = recherche_en_profondeur_rec_lim(etat_initial,est_final,opérateurs_applicables,etat_en_texte,{},limite)
        affiche_solution(etat_initial,ch,etat_en_texte)
       
